require 'json'
require 'uri'
require 'net/http'
# see the URL below for information on how to write OpenStudio measures
# start the measure
class IncorporaTablasDeTodosLosCombustibles < OpenStudio::Ruleset::WorkspaceUserScript

  # human readable name
  def name
    return " IncorporaTablasDeTodosLosCombustibles"
  end

  # human readable description
  def description
    return "Incorpora las tablas de todos los combustibles"
  end

  # human readable description of modeling approach
  def modeler_description
    return "Replace this text with an explanation for the energy modeler specifically.  It should explain how the measure is modeled, including any requirements about how the baseline model must be set up, major assumptions, citations of references to applicable modeling resources, etc.  The energy modeler should be able to read this description and understand what changes the measure is making to the model and why these changes are being made.  Because the Modeler Description is written for an expert audience, using common abbreviations for brevity is good practice."
  end

  # define the arguments that the user will input
  def arguments(workspace)
    args = OpenStudio::Ruleset::OSArgumentVector.new

    # the name of the zone to add to the model
    # zone_name = OpenStudio::Ruleset::OSArgument.makeStringArgument("zone_name", true)
    # zone_name.setDisplayName("New zone name")
    # zone_name.setDescription("This name will be used as the name of the new zone.")
    # args << zone_name

    return args
  end 

  # define what happens when the measure is run
  def run(workspace, runner, user_arguments)
    super(workspace, runner, user_arguments)

    # use the built-in error checking 
    if !runner.validateUserArguments(arguments(workspace), user_arguments)
      return false
    end

    # reporting initial condition of model
    runner.registerInitialCondition("Comenzamos...")
    

    formatoTabla_string = "    
Output:Meter,
    Diesel:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)

    formatoTabla_string = "    
Output:Meter,
    Propane:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)

    formatoTabla_string = "    
Output:Meter,
    Gasoline:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)

    formatoTabla_string = "   
Output:Meter,
    FuelOil#1:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)

    formatoTabla_string = "   
Output:Meter,
    FuelOil#2:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)

    formatoTabla_string = "   
Output:Meter,
    OtherFuel1:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)

    formatoTabla_string = "   
Output:Meter,
    OtherFuel2:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)


    formatoTabla_string = "   
Output:Meter,
    Coal:Facility,            !- Name
    Monthly;                !- Reporting Frequency
      "      
    idfObject = OpenStudio::IdfObject::load(formatoTabla_string)
    object = idfObject.get
    wsObject = workspace.addObject(object)








    # report final condition of model
    runner.registerFinalCondition("Fin")
    
    return true
 
  end

end 

# register the measure to be used by the application
IncorporaTablasDeTodosLosCombustibles.new.registerWithApplication
