# see the URL below for information on how to write OpenStudio measures
# http://nrel.github.io/OpenStudio-user-documentation/reference/measure_writing_guide/

# start the measure
class IntroduceTemperaturaCondicionesDeContorno < OpenStudio::Ruleset::WorkspaceUserScript

  # human readable name
  def name
    return "Introduce temperatura condiciones de contorno"
  end

  # human readable description
  def description
    return "Se excluyen las superficies que tienen huecos (EnergyPlus no lo permite)."
  end

  # human readable description of modeling approach
  def modeler_description
    return ""
  end

  # define the arguments that the user will input
  def arguments(workspace)
    args = OpenStudio::Ruleset::OSArgumentVector.new

    # Argumentos
    nombreContenidoEnLasSuperfiesAModificar = OpenStudio::Ruleset::OSArgument.makeStringArgument("nombreContenidoEnLasSuperfiesAModificar", true)
    nombreContenidoEnLasSuperfiesAModificar.setDisplayName("Nombre contenido en las superficies a modificar")
    nombreContenidoEnLasSuperfiesAModificar.setDescription("")
    nombreContenidoEnLasSuperfiesAModificar.setDefaultValue("Surface")
    args << nombreContenidoEnLasSuperfiesAModificar    
    
    
    
    
    temperaturaMediaEnero = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaEnero", true)
    temperaturaMediaEnero.setDisplayName("Temperatura media enero")
    temperaturaMediaEnero.setDescription("")
    temperaturaMediaEnero.setDefaultValue(15.0)
    args << temperaturaMediaEnero

    temperaturaMediaFebrero = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaFebrero", true)
    temperaturaMediaFebrero.setDisplayName("Temperatura media febrero")
    temperaturaMediaFebrero.setDescription("")
    temperaturaMediaFebrero.setDefaultValue(15.0)
    args << temperaturaMediaFebrero

    temperaturaMediaMarzo = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaMarzo", true)
    temperaturaMediaMarzo.setDisplayName("Temperatura media marzo")
    temperaturaMediaMarzo.setDescription("")
    temperaturaMediaMarzo.setDefaultValue(15.0)
    args << temperaturaMediaMarzo

    temperaturaMediaAbril = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaAbril", true)
    temperaturaMediaAbril.setDisplayName("Temperatura media abril")
    temperaturaMediaAbril.setDescription("")
    temperaturaMediaAbril.setDefaultValue(15.0)
    args << temperaturaMediaAbril


    temperaturaMediaMayo = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaMayo", true)
    temperaturaMediaMayo.setDisplayName("Temperatura media mayo")
    temperaturaMediaMayo.setDescription("")
    temperaturaMediaMayo.setDefaultValue(15.0)
    args << temperaturaMediaMayo


    temperaturaMediaJunio = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaJunio", true)
    temperaturaMediaJunio.setDisplayName("Temperatura media junio")
    temperaturaMediaJunio.setDescription("")
    temperaturaMediaJunio.setDefaultValue(15.0)
    args << temperaturaMediaJunio
    
    temperaturaMediaJulio = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaJulio", true)
    temperaturaMediaJulio.setDisplayName("Temperatura media julio")
    temperaturaMediaJulio.setDescription("")
    temperaturaMediaJulio.setDefaultValue(15.0)
    args << temperaturaMediaJulio    


    temperaturaMediaAgosto = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaAgosto", true)
    temperaturaMediaAgosto.setDisplayName("Temperatura media agosto")
    temperaturaMediaAgosto.setDescription("")
    temperaturaMediaAgosto.setDefaultValue(15.0)
    args << temperaturaMediaAgosto    

    temperaturaMediaSeptiembre = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaSeptiembre", true)
    temperaturaMediaSeptiembre.setDisplayName("Temperatura media septiembre")
    temperaturaMediaSeptiembre.setDescription("")
    temperaturaMediaSeptiembre.setDefaultValue(15.0)
    args << temperaturaMediaSeptiembre  
    
    temperaturaMediaOctubre = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaOctubre", true)
    temperaturaMediaOctubre.setDisplayName("Temperatura media octubre")
    temperaturaMediaOctubre.setDescription("")
    temperaturaMediaOctubre.setDefaultValue(15.0)
    args << temperaturaMediaOctubre  
    
    temperaturaMediaNoviembre = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaNoviembre", true)
    temperaturaMediaNoviembre.setDisplayName("Temperatura media noviembre")
    temperaturaMediaNoviembre.setDescription("")
    temperaturaMediaNoviembre.setDefaultValue(15.0)
    args << temperaturaMediaNoviembre  
    
    temperaturaMediaDiciembre = OpenStudio::Ruleset::OSArgument.makeDoubleArgument("temperaturaMediaDiciembre", true)
    temperaturaMediaDiciembre.setDisplayName("Temperatura media diciembre")
    temperaturaMediaDiciembre.setDescription("")
    temperaturaMediaDiciembre.setDefaultValue(15.0)
    args << temperaturaMediaDiciembre  
      


    return args
  end 

  # define what happens when the measure is run
  def run(workspace, runner, user_arguments)
    super(workspace, runner, user_arguments)

    # use the built-in error checking 
    if !runner.validateUserArguments(arguments(workspace), user_arguments)
      return false
    end

    # assign the user inputs to variables
    nombreContenidoEnLasSuperfiesAModificar = runner.getStringArgumentValue("nombreContenidoEnLasSuperfiesAModificar", user_arguments)
    temperaturaMediaEnero = runner.getDoubleArgumentValue("temperaturaMediaEnero", user_arguments)
    temperaturaMediaFebrero = runner.getDoubleArgumentValue("temperaturaMediaFebrero", user_arguments)
    temperaturaMediaMarzo = runner.getDoubleArgumentValue("temperaturaMediaMarzo", user_arguments)
    temperaturaMediaAbril = runner.getDoubleArgumentValue("temperaturaMediaAbril", user_arguments)
    temperaturaMediaMayo = runner.getDoubleArgumentValue("temperaturaMediaMayo", user_arguments)
    temperaturaMediaJunio = runner.getDoubleArgumentValue("temperaturaMediaJunio", user_arguments)
    temperaturaMediaJulio = runner.getDoubleArgumentValue("temperaturaMediaJulio", user_arguments)
    temperaturaMediaAgosto = runner.getDoubleArgumentValue("temperaturaMediaAgosto", user_arguments)
    temperaturaMediaSeptiembre = runner.getDoubleArgumentValue("temperaturaMediaSeptiembre", user_arguments)
    temperaturaMediaOctubre = runner.getDoubleArgumentValue("temperaturaMediaOctubre", user_arguments)
    temperaturaMediaNoviembre = runner.getDoubleArgumentValue("temperaturaMediaNoviembre", user_arguments)
    temperaturaMediaDiciembre = runner.getDoubleArgumentValue("temperaturaMediaDiciembre", user_arguments)


    
    # Lista de las ventanas: Excluimos las paredes que tienen ventanas
    listaVentanas = workspace.getObjectsByType("FenestrationSurface:Detailed".to_IddObjectType)    
    
    listaSuperficiesAExcluirPorTenerVentanas = []
    listaVentanas.each {|ventana| listaSuperficiesAExcluirPorTenerVentanas << ventana.getString(3).get}


    # listaSuperficies a modificar las condiciones de cotorno
    listaSuperficies = workspace.getObjectsByType("BuildingSurface_Detailed".to_IddObjectType)    
    listaSuperficies = listaSuperficies.select { |x| x.getString(0).get.include? nombreContenidoEnLasSuperfiesAModificar }
    listaSuperficies = listaSuperficies.select { |x| not listaSuperficiesAExcluirPorTenerVentanas.include? x.getString(0).get }

    # reporting initial condition of model
    runner.registerInitialCondition("El modelo contiene  #{listaSuperficies.size} superficies exteriores.")


    calendarioTemperaturasString = "
Schedule:Compact,
  Calendario temperaturas, !- Name
  Temperature, !- Schedule Type Limits Name
  Through: 1/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaEnero},                                      !- Field 4
  Through: 2/28,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaFebrero},                                      !- Field 4
  Through: 3/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaMarzo},                                      !- Field 4
  Through: 4/30,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaAbril},                                      !- Field 4
  Through: 5/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaMayo},                                      !- Field 4
  Through: 6/30,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaJunio},                                      !- Field 4
  Through: 7/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaJulio},                                      !- Field 4
  Through: 8/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaAgosto},                                      !- Field 4
  Through: 9/30,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaSeptiembre},                                      !- Field 4
  Through: 10/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaOctubre},                                      !- Field 4
  Through: 11/30,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaNoviembre},                                      !- Field 4
  Through: 12/31,                         !- Field 1
  For: AllDays,                           !- Field 2
  Until: 24:00,                           !- Field 3
  #{temperaturaMediaDiciembre};                                     !- Field 4                      
        "
    idfObject = OpenStudio::IdfObject::load(calendarioTemperaturasString)
    object = idfObject.get
    wsObject = workspace.addObject(object)

  otherSideCoefficientsString = "
SurfaceProperty:OtherSideCoefficients,
      coeficientesCondicionesDeContorno,   !- Name
      0.0,                       !- Combined Convective/Radiative Film Coefficient {W/m2-K}
      0.0,                !- Constant Temperature {C}
      1.0,                !- Constant Temperature Coefficient
      0.0,                !- External Dry-Bulb Temperature Coefficient
      0.0,                !- Ground Temperature Coefficient
      0.0,                !- Wind Speed Coefficient
      0.0,                !- Zone Air Temperature Coefficient
      Calendario temperaturas;  !- Constant Temperature Schedule Name"

    idfObject = OpenStudio::IdfObject::load(otherSideCoefficientsString)
    object = idfObject.get
    wsObject = workspace.addObject(object)


    # Aplicamos a las superficies las nuevas condiciones de contorno    
    nombresDeLasSuperficies = []
    listaSuperficies.each do |superficie|
      superficie.setString(4,"OtherSideCoefficients")
      superficie.setString(5,"coeficientesCondicionesDeContorno")
    end
    
    



    runner.registerFinalCondition("Se han modificado  #{listaSuperficies.size} superficies.")
    
    return true
 
  end

end 

# register the measure to be used by the application
IntroduceTemperaturaCondicionesDeContorno.new.registerWithApplication
